#ifndef STRUCT_NAME
# define STRUCT_NAME startup_image
# include "startup_screen.c"
#endif

#include <assert.h>
#include <stdlib.h>
#include <stdint.h>
#include <stdio.h>

#define xstr(s) str(s)
#define str(s) #s

int main()
{
    int x, y;
    printf("/* 565 RGB C-Source image dump */\n"
	   "\n"
	   "static const struct {\n"
	   "  unsigned int   width;\n"
	   "  unsigned int   height;\n"
	   "  char          *comment;\n"
	   "  uint16_t       pixel_data[%d * %d + 1];\n"
	   "} %s = {\n"
	   "  %d, %d,\n"
	   "  \"%s\",\n"
	   "  {\n",
	   STRUCT_NAME.width, STRUCT_NAME.height, xstr(STRUCT_NAME),
	   STRUCT_NAME.width, STRUCT_NAME.height,
	   STRUCT_NAME.comment);

    assert(sizeof(short)==2);
    for (y=0; y < STRUCT_NAME.height; y++) {
	printf("    ");
	for (x=0; x < STRUCT_NAME.width; x++) {
	    const unsigned char *pixel = STRUCT_NAME.pixel_data +
		(STRUCT_NAME.bytes_per_pixel *
		 (x + (y * STRUCT_NAME.width)));
	    unsigned char red=pixel[0], green=pixel[1], blue=pixel[2];
	    uint16_t p= ((red >> 3) << 11) | ((green >> 2) << 5) | (blue >> 3);
	    printf("%hu,", p);
	}
	printf("\n");
    }
    printf("    0\n"
	   "  }\n"
	   "};\n");
    return 0; /* success */
}
