#include <assert.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include "fbutil.h"

int main()
{
    struct fbinfo fbi;
    int st, xoffset, yoffset;
    char *fbp;
    struct image *startup_image;
    struct stat si_st;
    int fd;

    fd = open("images/startup.565", O_RDONLY);
    assert(fd >= 0);
    st = fstat(fd, &si_st);
    assert(!st);
    startup_image = mmap(NULL, si_st.st_size, PROT_READ, MAP_SHARED, fd, 0);
    assert(startup_image != MAP_FAILED);

    st = fb_open("/dev/fb0", &fbi);
    assert(!st);

    /* center the pic */
    xoffset = ((int)fbi.vinfo.xres - (int)startup_image->width) / 2;
    yoffset = ((int)fbi.vinfo.yres - (int)startup_image->height) / 2;
    /* blit it */
    fb_put(&fbi, xoffset, yoffset, startup_image);
    /* done! */
    fb_close(&fbi);
}
