#!/usr/bin/python2.5
from __future__ import division, with_statement
from pyfb import *
import os, time

def initial_setup():
    global xoffset, yoffset, topx, topy
    fb = FrameBuffer('/dev/fb0')
    fb.load('startup', 'images/startup.565')
    for n in xrange(0, 20):
        fb.load('xo anim %d' % n, 'images/xo_anim%02d.565' % n)

    xoffset = (fb.width - fb['startup'].width) // 2
    yoffset = (fb.height - fb['startup'].height) // 2
    fb.draw(xoffset, yoffset, fb['startup'])

    topx = (fb['startup'].width - fb['xo anim 0'].width) // 2
    topy = (fb['startup'].height- fb['xo anim 0'].height) // 2
    return fb

def server_loop(s, fb):
    global xoffset, yoffset, topx, topy
    import socket
    s.settimeout(0.1)
    finishing = False
    while not finishing:
        for n in xrange(0, 20):
            try:
                cmd = s.recvfrom(256)[0]
                if cmd == 'quit': finishing = True
            except socket.timeout:
                pass
            fb.draw(xoffset + topx, yoffset + topy, fb['xo anim %d' % n])

def clean_up():
    # close framebuffer?
    pass


if __name__ == '__main__':
    from socket import *
    import sys
    # create the fifo given on the command-line then fork.
    SOCKET_NAME = sys.argv[1] if len(sys.argv) >= 2 else '/tmp/gui-sock'
    s = socket(AF_UNIX, SOCK_DGRAM)
    s.bind(SOCKET_NAME)
    # an extra command-line argument will cause us not to fork
    if len(sys.argv)>2 or os.fork() == 0:
        # i'm the child!
        server_loop(s, initial_setup())
        s.sendto('done', 0, SOCKET_NAME)
        # clean up the socket
        os.unlink(SOCKET_NAME)
        s.close()
        # clean up other details
        clean_up()
